import 'package:test/test.dart';

import 'package:primitive_wrappers/primitive_wrappers.dart';

void main() {
  group('Bool constructor, getter', () {
    test('set default (false) value on creation', () {
      var wrapper = Bool();
      assert(wrapper.$ == false);
    });
    test('set bool value on creation', () {
      var _wrapper = Bool(init: true);
      expect(_wrapper.$, true);
      var _wrapper2 = Bool(init: false);
      expect(_wrapper2.$, false);
    });
  });

  group('Bool setter', () {
    Bool _wrapper;
    Bool _wrapper2;
    setUp(() {
      _wrapper = Bool();
      _wrapper2 = Bool();
    });
    test('setter \$ sets given value', () {
      _wrapper.$ = true;
      _wrapper2.$ = false;
      expect(_wrapper.$, true);
      expect(_wrapper2.$, false);
    });
  });

  group('Bool queals operator', () {
    Bool _wrapper;
    Bool _wrapper2;
    setUp(() {
      _wrapper = Bool();
      _wrapper2 = Bool(init: true);
    });
    test('equals operator works with primitive bool', () {
      expect(_wrapper == false, true);
      expect(_wrapper == true, false);
    });
    test('equals operator works with Bool wrapper', () {
      expect(_wrapper == Bool(), true);
      expect(_wrapper2 == Bool(), false);
      expect(_wrapper == _wrapper2, false);
      _wrapper2.$ = false;
      expect(_wrapper == _wrapper2, true);
    });
  });
}
